unit SafeCalc;

{$N+}

interface

type
 TSCVariables = array['A'..'Z'] of Extended;
 TRaiseErrorProc = Procedure(ErrMsg: String);

 var
  Variables : TSCVariables;
  REP : TRaiseErrorProc;

  function CalcStr(const S:string):Extended;   {᫥  ࠦ}

 implementation

Function Inttostr(Int:LongInt):String;
var
 buf: string[11];
begin
 Str(Int, buf);
 Inttostr := buf;
end;

function Power(Base, Exponent: Extended): Extended;
var
 R: Extended;
begin
 if Exponent = 0 then R := 1
  else if (Base = 0) and (Exponent > 0) then R := 0
  else begin
   R := Exp(Exponent * Ln(Abs(Base)));
   if Base<0 then R := -R;
   if Exponent < 0 then R := 1 / R;
  end;
 Power := R;
end;

function Addend(const S:string;var P:Integer):Extended; forward;
function Multiplier(const S:string;var P:Integer):Extended; forward;
function Func(const S:string;var P:Integer):Extended; forward;

  function Expr(const S:string;var P:Integer):Extended;
  var
   M: Extended;
   begin
    M := Addend(S,P);
    while S[P] in ['+','-'] do
     begin
      Inc(P);
      case S[P-1] of
       '+': M := M + Addend(S,P);
       '-': M := M - Addend(S,P);
      end {/case}
     end;
    Expr := M;
   end;

  function Addend;
  var
   M: Extended;
   begin
    M := Multiplier(S,P);
    while S[P] in ['*','/'] do
     begin
      Inc(P);
      case S[P-1] of
       '*': M := M * Multiplier(S,P);
       '/': M := M / Multiplier(S,P);
      end {/case}
     end;
    Addend := M;
   end;

function Multiplier;
 var
  J,D:Integer;
  M: Extended;
begin
 case UpCase(S[P]) of                        { ⨯ ⥫}
  '0'..'9':begin                             {᫮}
            Val(Copy(S,P,MaxInt), M, J);
            Val(Copy(S, P, J-1), M, D);
            P := P + J - 1
           end;
   '-':begin                                  {䨪 }
        Inc(P);
        M := -Multiplier(S,P)
       end;
      '[':begin                                  {⭠ ᪮ - 祭}
                                                 {楫 .}
           Inc(P);
           M := Expr(S,P);
           if M>=0 then
            M := Int(M)
           else
            M := Int(M) - 1;
           if S[P]=']' then                      {   }
            Inc(P)
           else
            REP(' '']''  樨 ' + IntToStr(P))
          end;
      '(':begin                                  {㣫 ᪮ - }
                                                 {浪 ⢨.}
           Inc(P);
           M := Expr(S,P);
           if S[P]=')' then                      {   }
            Inc(P)
           else
            REP(' '')''  樨 '+IntToStr(P))
          end;
      'A'..'Z': M := Func(S,P);                {㪢 - 㭪  ६}
      else
       REP('⠪᪠ 訡  樨 '+IntToStr(P))
                                                 { 㣮 ᨬ -
                                                 ᨭ⠪᪠ 訡}
     end;
      Multiplier := M;
    end;

  function Func;
   var N:string;
       D,ISN:Extended;
       I,K:LongInt;
       PO:Integer;
       Bl:Boolean;
    begin
     N:=UpCase(S[P]);
     Inc(P);
     {   ।  㭪樨   }
     while UpCase(S[P]) in ['0'..'9','A'..'Z'] do
      begin
       N:=N+UpCase(S[P]);
       Inc(P)
      end;
     if S[P]='(' then                            {᫨   - ᪮,  - 㭪}
      begin
       Inc(P);
       if N='COS' then   {ᨭ}
        Func:=Cos(Expr(S,P))
       else
        if N='SQRT' then   { ७}
         Func:=Sqrt(Expr(S,P))
        else
         if N='SIN' then   {}
          Func := Sin(Expr(S,P))
         else
          if N='TAN' then   {}
          begin
           D := Expr(S,P);
           Func := sin(D)/cos(D);
          end else
          if N='COTAN' then   {Ko}
          begin
           D := Expr(S,P);
           Func := cos(D)/sin(D);
          end
          else
             if N='ARCTG' then   {⠭}
              Func:=ArcTan(Expr(S,P))
             else
              if N='EXP' then   {ᯮ}
               Func:=Exp(Expr(S,P))
              else
               if N='LN' then   {ࠫ }
                Func:=Ln(Expr(S,P))
               else
                 if N='SQR' then   {  }
                   Func:=Sqr(Expr(S,P))
                  else
                   if N='POWER' then   {  ⥯}
                    begin
                     D:=Expr(S,P);
                     if S[P]<>',' then
                      REP(' '',''  樨 '+IntToStr(P));
                     Inc(P);
                     Func := Power (D,Expr(S,P))
                    end
                   else
                     if N='ABS' then   { ᫠}
                      Func:=Abs(Expr(S,P))
                       else
                        if N='SGN' then   { (ᨣ) ᫠}
                          begin
                           ISN := Expr(S,P);
                           if ISN>0 then
                             Func := 1
                              else
                               if ISN<0 then
                                Func := -1
                               else
                                Func := 0
                             end
                            else
                             if N='SUM' then   {   㬬 ᪮쪨 ᫠,
                                               㬬஢   i.
                                                筮  ᮮ⢥
                                               ᪮ 让 㪢 "ᨣ".
                                                ࠬ - 砫쭮 祭
                                               , ன - 筮, ⨩ -
                                               㬬㥬 ࠦ,  
                                                i. ਬ, ࠦ
                                               Sum(1,5,Sqr(i))  㬬
                                               ⮢ 楫 ᥫ   
                                               . ࠭  ࠬ
                                               㣫  楫 ᫠.}
                              begin
                               I:=Trunc(Expr(S,P));
                               if S[P]<>',' then
                                REP(' '',''  樨 '+IntToStr(P));
                               Inc(P);
                               K:=Trunc(Expr(S,P));
                               if S[P]<>',' then
                                REP(' '',''  樨 '+IntToStr(P));
                               if I>K then
                                REP(' ࠭    ');
                               ISN:=Variables['I'];    { ஥ 祭 i}
                               Inc(P);
                               PO := P;{    ࠦ ਤ  ᪮쪮
                                        ࠧ, ⮬  .}
                               D:=0;
                               repeat
                                P:=PO;
                                Variables['I']:=I;
                                D:=D+Expr(S,P);
                                {   塞 祭 ࠦ ⮫쪮 ࠧ, ᪮쪮
                                    㦭, ⠢ ࠧ 祭 i   }
                                Inc(I)
                               until I>K;
                               Variables['I']:=ISN;   {⠭ 祭 i}
                               Func:=D
                              end
                             else
                              if N='MAX' then   {ᨬ쭮 祭  ᯨ᪠.
                                                ᫮ ⮢  ᯨ᪥ ந쭮,
                                                   .}
                               begin
                                D:=Expr(S,P);
                                while S[P]=',' do   {᫨  - ᯨ᮪   稫}
                                 begin
                                  Inc(P);
                                  ISN:=Expr(S,P);
                                  if ISN>D then
                                   D:=ISN
                                 end;
                                Func:=D
                               end
                              else
                               if N='MIN' then   {쭮 祭  ᯨ᪠}
                                begin
                                 D:=Expr(S,P);
                                 while S[P]=',' do
                                  begin
                                   Inc(P);
                                   ISN:=Expr(S,P);
                                   if ISN<D then
                                    D:=ISN
                                  end;
                                 Func:=D
                                end else REP('⭠ 㭪 ' + N);
       if S[P]=')' then   {  }
        Inc(P)
       else REP(' '')''  樨 '+IntToStr(P));
      end
     else
      if Length(N)=1 then
       Func:=Variables[N[1]]
      else
       if N='PI' then
        Func := Pi
       else REP(N+'   ⨬ ')
    end;

function CalcStr;
 var P:Integer;
begin
 P:=1;
 CalcStr := Expr(S+' ', P);
end;

procedure RaiseError(ErrMsg: String);
begin
 Writeln(']> ', ErrMsg);
 halt;
end;

begin
 REP := RaiseError;
 FillChar(Variables, SizeOf(Variables), 0);
end.